<template>
  <v-page :header-text="headerText">
    <input
        v-model="email"
        :disabled="inProgress"
        placeholder="Email"
        ref="emailInput"
        @input="onInput"
        @keyup.enter="onSignUp"
    />
    <br/>
    <InputNewPass
        v-model="newPass"
        :disabled="inProgress"
        :pass-complexity-calculator="passComplexityCalculator"
        ref="newPassInput"
        @input="onInput"
        @keyup-enter="onSignUp"
    />
    <FormErrorMessage v-if="error">{{ error }}</FormErrorMessage>
    <br/>
    <v-button :in-progress="inProgress" @click="onSignUp">Sign up</v-button>
    <br/>
    <v-button-link :disabled="inProgress" to="/user-auth">back</v-button-link>
  </v-page>
</template>

<script>
  import { createNamespacedHelpers } from 'vuex'

  import { InputNewPass } from 'zeus-common'
  import { FormErrorMessage } from 'zeus-common'
  import { VPage } from 'zeus-common'
  import { VButton } from 'zeus-common'
  import { VButtonLink } from 'zeus-common'

  import { getPassComplexity, PassComplexity } from 'zeus-common'
  import { animateError } from 'zeus-common'
  import { SignUpError } from '@/pages/sign-up/service'
  import { header as headerText } from '@/config'

  const { mapState } = createNamespacedHelpers('signUp')

  export default {
    name: 'SignUpPage',
    components: { VButtonLink, VButton, VPage, FormErrorMessage, InputNewPass },
    data: () => ({
      headerText: headerText,
      email: '',
      newPass: { pass: '', passConfirmation: '' },
      passComplexityCalculator: getPassComplexity,
    }),
    computed: {
      ...mapState([ 'inProgress', 'error' ])
    },
    beforeDestroy() {
      this.$store.commit('signIn/resetError')
    },
    watch: {
      error(error) { switch (error) {
        case SignUpError.EMAIL_ALREADY_EXISTS:
        case SignUpError.EMAIL_IS_INCORRECT:
          animateError(this.$refs.emailInput)
          break
        case SignUpError.PASSWORDS_ARE_DIFFERENT:
          animateError(this.$refs.newPassInput.$refs.passInput)
          animateError(this.$refs.newPassInput.$refs.passConfirmationInput)
          break
        default: break
      }}
    },
    methods: {
      onSignUp() {
        this.onInput()
        let errorCounter = 0

        if (!this.email) {
          animateError(this.$refs.emailInput)
          errorCounter++
        }
        if (!this.newPass.pass || this.newPass.complexity === PassComplexity.Low) {
          animateError(this.$refs.newPassInput.$refs.passInput)
          errorCounter++
        }
        if (!this.newPass.passConfirmation) {
          animateError(this.$refs.newPassInput.$refs.passConfirmationInput)
          errorCounter++
        }

        if (errorCounter === 0) {
          this.$store.dispatch('signUp/signUp', {
            email: this.email,
            pass: this.newPass.pass,
            passConfirmation: this.newPass.passConfirmation,
            onSuccess: (() => {
              this.$store.commit('confirmationEmailSent/setCredentials', { email: this.email, pass: this.newPass.pass })
              this.$router.push('/confirmation-email-sent')
            }).bind(this)
          })
        }
      },
      onInput() {
        if (this.error != null) {
          this.$store.commit('signUp/resetError')
        }
      }
    }
  }
</script>